comment +
_____________________________________________________________________________
   _____  | | |__  | |  __| |  | |__   ____  | | | |__  | |_____| |  | | |
__|     |_| |____| |_| |____|  |__  | |____| |_| |____| |_________|  |_| |___
  .___.__  ._______.___    .___   | |   ._____.___ .______  .______ ._______
  :   |  \ : .____/|   |   |   |  | |_  :         |:      \ \____  |: .____/
  |   :   || : _/\ |   |   |   |  |___| |   \  /  ||   .   |/  ____|| : _/\
  |   .   ||   /  \|   |/\ |   |/\      |   |\/   ||   :   |\      ||   /  \
  |___|   ||_.: __/|   /  \|   /  \     |___| |   ||___|   | \__:__||_.: __/
__    |___|   :/   |______/|______/  __   __  |___|    |___|      _   _______
  |      _ __    .--.    ___    _   |  | |__| _   _______     ___| | |  _____
  |_____| |  |___|  |__ |   |__| |__|  |_____| | |_____  |_  |  ___| | |_____
__________|____|__________|___ _____|__________|_______|___|_|__|____|_______
 256 byte intro "HELL MAZE" . Code by bitl/7dump (2023) . aleks_gs@yahoo.com
                                                  __
 GrEeTiNgS  & ReSpEct:                           |  |  For compilation  use:
 sensenstahl,  TomCatAbaddon, iONic,   Hellmood  |  |  Turbo  Assembler 2.02
 baze,  p01,  pestis,   Asato,  rrrola, Optimus  |  |  tasm /m2 hellmaze.asm
 superogue,  Kuemmel,  Digimind,   Manwe,   LBi  |__|  tlink /t hellmaze.obj

comment end! +

mode60  = 0        ; enable tweaked 60hz VGA mode
FAST_PC = 1        ; 0 or 1 (divider of movement's variable)
CAMERA_HEIGHT = 4

xtr  = 0;
v128 = 2;
ytr  = 4;
q    = 6;

.model tiny
.data
_xtr    DW 0A000h   ;0
_v128   DW 128      ;2
;_ytr   DW 0        ;4
;_q     DW 0        ;6

IF mode60
vga60 DW 0b06h, 3e07h, 0c310h, 8c11h, 8f12h, 9015h, 0b16h
ENDIF

.code
.486
org 0100h

start:

mov al,13h
int 10h

add dh, al                 ; cs + 1300h
mov fs, dx                 ; segment for texture

IF mode60
mov dx, 3d4h               ; Set tweaked 60hz VGA mode 320x200
push dx
mov al, 11h
out dx, al
inc dx
in al, dx
and al, 7fh
out dx, al
mov dx, 3C2h
mov al, 0e3h
out dx, al
pop dx
lea si, vga60
mov cx, 7
rep outsw
ENDIF

;**********************************************************************
; MAZE TEXTURE AND PALETTE GENERATOR
;**********************************************************************
xor di, di
@texture: ;for y:=0 to 255 do for x:=0 to 255 do begin
mov ax, di
shr al, 3   ;  xx:= x div 8;
shr ah, 3   ;  yy:= y div 8;
add ax, 0101h
mov bx, ax  ;  xc:= xx and 1;
and bx, 257 ;  yc:= yy and 1;
mov cx, ax  ;  ra:=word((xx xor yy) * (yy * xx) + 200);
xor cl, ch
mul ah
mul cl
add ax, 200
xor al, ah  ;  ra:=low(ra) xor hi(ra);
mov dl, ah
mov cx, bx  ;  col:=byte((xc and yc) or (xc xor yc) * (ra and 1));
xor cl, ch
and al, 1
mul cl
and bl, bh
or al, bl
jz @zero
in ax, 40h      ; Add noise
xadd si, ax
shr al, 4
add al, 128
add al, dl
@zero:
mov fs:[di], al
mov dx, 3c8h    ; Setup palette
mov ax, di
out dx, al
inc dx
sar al, 1
js @pale2
out dx, al
mul al
shr ax, 6
out dx, al
@pale2:
mov al, 6
out dx, al
jns @pale3
sub ax, di
shr al, 2
out dx, al
add al, 3
out dx, al
@pale3:
inc di
jnz @texture


lea si, _xtr                    ; set SI to DATA-offset
mov es, ds:[si]                 ; load 0xA000 to ES

fninit

;**********************************************************************
; MAIN LOOP
;**********************************************************************
@mainloop:
dec ax              ; movement
push ax
IF FAST_PC
   shr ax, 1
ENDIF
mov ds:[si+q], ax

mov di, 319
@maindraw: ;for x:=0 to 319 do begin
  push di

  ;Tcos := round(cos(q/128)*128);  Tsin := round(sin(q/128)*128);
  fild word ptr ds:[si+v128]            ;   128  |
  fild word ptr ds:[si+q]               ;    q   |  128
  fdiv st(0), st(1)                     ;  q/128 |  128
  fsincos                               ;  cos   |  sin   |  128
  fld st(2)                             ;  128   |  cos   |  sin  |  128
  fmul st(1), st(0)                     ;  128   |  Tcos  |  sin  |  128
  fmulp st(2), st(0)                    ;  Tcos  |  Tsin  |  128

  ; (x-160)
  mov ds:[si+xtr], di
  sub word ptr ds:[si+xtr], 160

  ;sx:=Tcos*(x-160);
  fld st                                ;  Tcos  |  Tcos   |  Tsin  |  128
  fimul word ptr ds:[si+xtr]            ;   sx   |  Tcos   |  Tsin  |  128

  ;ytr:= sx - Tsin*128;
  fld st(3)                             ;   128  |   sx    |  Tcos  |  Tsin  |  128
  fmul st(0), st(3)                     ;Tsin*128|   sx    |  Tcos  |  Tsin  |  128
  fsubp st(1), st(0)                    ;   ytr  |  Tcos   |  Tsin  |  128
  fistp word ptr ds:[si+ytr]            ;  Tcos  |  Tsin   |  128   |

  ;cx:=Tsin*(x-160); xtr:= cx + Tcos*128;
  fmulp st(2), st(0)                    ;  Tsin  | Tcos*128|
  fimul word ptr ds:[si+xtr]            ;   cx   | Tcos*128|
  faddp st(1), st(0)                    ;  xtr   |
  fistp word ptr ds:[si+xtr]

  xor bp, bp
  mov cx, 0c8c8h  ; ch=200, cl=200
  @draw_column:   ;for y:=1 to 199 do begin

      add bp, CAMERA_HEIGHT
      mov ax, ds:[si+xtr]        ;xt:=xtr div (y*4);
      cwd
      idiv bp
      add ax, ds:[si+q]
      xchg ax, bx

      mov ax, ds:[si+ytr]        ;yt:=ytr div (y*4);
      cwd
      idiv bp
      sub ax, ds:[si+q]

      add bh, al                 ;col:=mem[vaddr2:word(xt+yt shl 8)];
      mov al, fs:[bx]

      mov dl, ch                 ; fogging
      shr dl, 2

      test al, al
      jnz @not_zero
          mov al, cl             ; col:=col2;
          inc cl                 ; inc(col2);
          jmp @draw
      @not_zero:
          mov cl, al             ; col2:=col+63;
          add cl, 63
          add al, dl             ; col:=col+fog;
      @draw:
          add al, dl             ; col:=col+fog;
          stosb                  ; mem[vaddr:vdi]:=col;
          add di, 319            ; vdi:=vdi+320;
  dec ch
  jnz @draw_column
pop di
dec di
jns @maindraw


     mov  dx, 3DAh           ; Wait for vertical retrace
IF mode60
@w1:
     in   al, dx
     test al, 8
     jnz  @w1
ENDIF
@w2:
     in   al, dx
     test al, 8
     jz   @w2

in al, 60h               ; wait for any key
das
pop ax
jp @mainloop             ; none received, start over


;**********************************************************************
; EXIT
;**********************************************************************
IF mode60
   mov ax, 3                ; back to text
   int 10h                  ; mode
ENDIF
ret
end start

